Index: trunk/NEMO/OPA_SRC/DIA/diaptr.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 508)
@@ -5,4 +5,8 @@
    !!                 (please no more than 2 lines)
    !!=====================================================================
+   !! History :  9.0  !  03-09  (C. Talandir, G. Madec)  Original code
+   !!            9.0  !  06-01  (A. Biastoch)  Allow sub-basins computation
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   dia_ptr      : Poleward Transport Diagnostics module
@@ -14,9 +18,4 @@
    !!                : flux array; Generic interface: ptr_vj_3d, ptr_vj_2d
    !!----------------------------------------------------------------------
-   !! History :
-   !!   9.0  !  03-09  (C. Talandir, G. Madec)  Original code
-   !!   9.0  !  06-01  (A. Biastoch)  Allow sub-basins computation
-   !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce           ! ocean dynamics and active tracers
    USE dom_oce       ! ocean space and time domain
@@ -26,5 +25,6 @@
    USE dianam
    USE phycst
-   USE ioipsl          ! NetCDF IPSL library
+   USE iom
+   USE ioipsl         
    USE daymod
 
@@ -36,39 +36,34 @@
    END INTERFACE
 
-   !! *  Routine accessibility
-   PUBLIC dia_ptr_init   ! call in opa module
-   PUBLIC dia_ptr        ! call in step module
-   PUBLIC ptr_vj         ! call by tra_ldf & tra_adv routines
-   PUBLIC ptr_vjk        ! call by tra_ldf & tra_adv routines
-
-   !! * Share Module variables
-   LOGICAL, PUBLIC ::       & !!! ** init namelist (namptr) **
-      ln_diaptr = .FALSE.,  &  !: Poleward transport flag (T) or not (F)
-      ln_subbas = .FALSE.      !: Atlantic/Pacific/Indian basins calculation
-   INTEGER, PUBLIC ::       & !!: ** ptr namelist (namptr) **
-      nf_ptr = 15              !: frequency of ptr computation
-   REAL(wp), PUBLIC, DIMENSION(jpj) ::   &   !!: poleward transport
-      pht_adv, pst_adv,     &  !: heat and salt: advection
-      pht_ove, pst_ove,     &  !: heat and salt: overturning
-      pht_ldf, pst_ldf,     &  !: heat and salt: lateral diffusion
-#if defined key_diaeiv
-      pht_eiv, pst_eiv,     &  !: heat and salt: bolus advection
-#endif
-      ht_atl,ht_ind,ht_pac, &  !: heat
-      st_atl,st_ind,st_pac     !: salt
-   REAL(wp),DIMENSION(jpi,jpj) ::   &
-      abasin,pbasin,ibasin     !: return function value
+   PUBLIC   dia_ptr_init   ! call in opa module
+   PUBLIC   dia_ptr        ! call in step module
+   PUBLIC   ptr_vj         ! call by tra_ldf & tra_adv routines
+   PUBLIC   ptr_vjk        ! call by tra_ldf & tra_adv routines
+
+   !!! ** init namelist (namptr)
+   LOGICAL , PUBLIC                 ::   ln_diaptr = .FALSE.   !: Poleward transport flag (T) or not (F)
+   LOGICAL , PUBLIC                 ::   ln_subbas = .FALSE.   !: Atlantic/Pacific/Indian basins calculation
+   INTEGER , PUBLIC                 ::   nf_ptr = 15           !: frequency of ptr computation
+
+   REAL(wp), PUBLIC, DIMENSION(jpj) ::   pht_adv, pst_adv      !: heat and salt poleward transport: advection
+   REAL(wp), PUBLIC, DIMENSION(jpj) ::   pht_ove, pst_ove      !: heat and salt poleward transport: overturning
+   REAL(wp), PUBLIC, DIMENSION(jpj) ::   pht_ldf, pst_ldf      !: heat and salt poleward transport: lateral diffusion
+#if defined key_diaeiv
+   REAL(wp), PUBLIC, DIMENSION(jpj) ::   pht_eiv, pst_eiv      !: heat and salt poleward transport: bolus advection
+#endif
+   REAL(wp), PUBLIC, DIMENSION(jpj) ::   ht_atl,ht_ind,ht_pac  !: heat
+   REAL(wp), PUBLIC, DIMENSION(jpj) ::   st_atl,st_ind,st_pac  !: salt
+
      
 
-   !! Module variables
-   REAL(wp), DIMENSION(jpj,jpk) ::   &  
-      tn_jk  , sn_jk  ,  &  !: "zonal" mean temperature and salinity
-      v_msf_atl       ,  &  !: "meridional" Stream-Function
-      v_msf_glo       ,  &  !: "meridional" Stream-Function
-      v_msf_ipc       ,  &  !: "meridional" Stream-Function
-#if defined key_diaeiv
-      v_msf_eiv       ,  &  !: bolus "meridional" Stream-Function
-#endif
-      surf_jk_r             !: inverse of the ocean "zonal" section surface
+   REAL(wp), DIMENSION(jpj,jpk) ::   tn_jk  , sn_jk  ,  &  !: "zonal" mean temperature and salinity
+      &                              v_msf_atl       ,  &  !: "meridional" Stream-Function
+      &                              v_msf_glo       ,  &  !: "meridional" Stream-Function
+      &                              v_msf_ipc       ,  &  !: "meridional" Stream-Function
+      &                              surf_jk_r             !: inverse of the ocean "zonal" section surface
+#if defined key_diaeiv
+   REAL(wp), DIMENSION(jpj,jpk) ::   v_msf_eiv                  !: bolus "meridional" Stream-Function
+#endif
+   REAL(wp), DIMENSION(jpi,jpj) ::   abasin, pbasin, ibasin     !: return function value
 
    !! * Substitutions
@@ -78,5 +73,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -94,17 +89,12 @@
       !!
       !! ** Action  : - p_fval: i-k-mean poleward flux of pva
-      !!
-      !!----------------------------------------------------------------------
-      !! * arguments
-      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj,jpk) ::   &
-         pva                         ! mask flux array at V-point
-
-      !! * local declarations
-      INTEGER  ::   ji, jj, jk        ! dummy loop arguments
-      INTEGER  ::   ijpj             ! ???
-      REAL(wp),DIMENSION(jpj) ::   &
-         p_fval                       ! function value
+      !!----------------------------------------------------------------------
+      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pva   ! mask flux array at V-point
+      !!
+      INTEGER                  ::   ji, jj, jk   ! dummy loop arguments
+      INTEGER                  ::   ijpj         ! ???
+      REAL(wp), DIMENSION(jpj) ::   p_fval       ! function value
       !!--------------------------------------------------------------------
-
+      !
       ijpj = jpj
       p_fval(:) = 0.e0
@@ -116,9 +106,8 @@
          END DO
       END DO
-
+      !
       IF( lk_mpp )   CALL mpp_sum( p_fval, ijpj )     !!bug  I presume
-
+      !
    END FUNCTION ptr_vj_3d
-
 
 
@@ -134,17 +123,12 @@
       !!
       !! ** Action  : - p_fval: i-k-mean poleward flux of pva
-      !!
-      !!----------------------------------------------------------------------
-      !! * arguments
-      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj) ::   &
-         pva                         ! mask flux array at V-point
-
-      !! * local declarations
-      INTEGER  ::   ji,jj             ! dummy loop arguments
-      INTEGER  ::   ijpj             ! ???
-      REAL(wp),DIMENSION(jpj) ::   &
-         p_fval                       ! function value
+      !!----------------------------------------------------------------------
+      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj) ::   pva   ! mask flux array at V-point
+      !!
+      INTEGER                  ::   ji,jj    ! dummy loop arguments
+      INTEGER                  ::   ijpj     ! ???
+      REAL(wp), DIMENSION(jpj) ::   p_fval   ! function value
       !!--------------------------------------------------------------------
-      
+      ! 
       ijpj = jpj
       p_fval(:) = 0.e0
@@ -154,9 +138,8 @@
          END DO
       END DO
-
+      !
       IF( lk_mpp )   CALL mpp_sum( p_fval, ijpj )     !!bug  I presume
- 
-    END FUNCTION ptr_vj_2d
-
+      ! 
+   END FUNCTION ptr_vj_2d
 
 
@@ -171,22 +154,16 @@
       !!
       !! ** Action  : - p_fval: i-k-mean poleward flux of pva
-      !!
-      !!----------------------------------------------------------------------
-      !! * arguments
-      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj,jpk) ::   &
-         pva                         ! mask flux array at V-point
-
-      !! * local declarations
-      INTEGER  ::   ji, jj, jk        ! dummy loop arguments
-      INTEGER, DIMENSION (1) :: ish
-      INTEGER, DIMENSION (2) :: ish2
-      REAL(wp),DIMENSION(jpj*jpk) ::   &
-         zwork                        ! temporary vector for mpp_sum
-      REAL(wp),DIMENSION(jpj,jpk) ::   &
-         p_fval                       ! return function value
+      !!----------------------------------------------------------------------
+      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pva   ! mask flux array at V-point
+      !!
+      INTEGER                      ::   ji, jj, jk   ! dummy loop arguments
+      INTEGER , DIMENSION (1)      ::   ish
+      INTEGER , DIMENSION (2)      ::   ish2
+      REAL(wp), DIMENSION(jpj*jpk) ::   zwork        ! temporary vector for mpp_sum
+      REAL(wp), DIMENSION(jpj,jpk) ::   p_fval       ! return function value
       !!--------------------------------------------------------------------
- 
+      ! 
       p_fval(:,:) = 0.e0
-
+      !
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
@@ -197,5 +174,5 @@
          END DO
       END DO
-
+      !
       IF(lk_mpp) THEN
          ish(1) = jpj*jpk  ;  ish2(1) = jpj  ;  ish2(2) = jpk
@@ -204,6 +181,7 @@
          p_fval(:,:)= RESHAPE( zwork, ish2 )
       END IF
-
+      !
    END FUNCTION ptr_vjk
+
 
    FUNCTION ptr_vtjk( pva )   RESULT ( p_fval )
@@ -218,20 +196,14 @@
       !!
       !! ** Action  : - p_fval: i-k-mean poleward flux of pva
-      !!
-      !!----------------------------------------------------------------------
-      !! * arguments
-      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj,jpk) ::   &
-         pva                         ! mask flux array at V-point
- 
-      !! * local declarations
-      INTEGER  ::   ji, jj, jk        ! dummy loop arguments
-      INTEGER, DIMENSION (1) :: ish
-      INTEGER, DIMENSION (2) :: ish2
-      REAL(wp),DIMENSION(jpj*jpk) ::   &
-         zwork                        ! temporary vector for mpp_sum
-      REAL(wp),DIMENSION(jpj,jpk) ::   &
-         p_fval                       ! return function value
+      !!----------------------------------------------------------------------
+      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pva   ! mask flux array at V-point
+      !!
+      INTEGER                     ::   ji, jj, jk   ! dummy loop arguments
+      INTEGER, DIMENSION (1)      ::   ish
+      INTEGER, DIMENSION (2)      ::   ish2
+      REAL(wp),DIMENSION(jpj*jpk) ::   zwork        ! temporary vector for mpp_sum
+      REAL(wp),DIMENSION(jpj,jpk) ::   p_fval       ! return function value
       !!-------------------------------------------------------------------- 
-
+      !
       p_fval(:,:) = 0.e0
       DO jk = 1, jpkm1
@@ -251,5 +223,5 @@
          p_fval(:,:)= RESHAPE(zwork,ish2)
       END IF
-
+      !
    END FUNCTION ptr_vtjk
 
@@ -259,16 +231,10 @@
       !!                  ***  ROUTINE dia_ptr  ***
       !!----------------------------------------------------------------------
-      !! * Moudules used
-      USE ioipsl
-
-      !! * Argument
       INTEGER, INTENT(in) ::   kt   ! ocean time step index
-
-      !! * Local variables
-      INTEGER ::   jk,jj,ji               ! dummy loop
-      REAL(wp) ::    &
-         zsverdrup,  &              ! conversion from m3/s to Sverdrup
-         zpwatt,     &              ! conversion from W    to PW
-         zggram                     ! conversion from g    to Pg
+      !!
+      INTEGER  ::   jk, jj, ji               ! dummy loop
+      REAL(wp) ::   zsverdrup,  &              ! conversion from m3/s to Sverdrup
+         &          zpwatt,     &              ! conversion from W    to PW
+         &          zggram                     ! conversion from g    to Pg
 
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::  &
@@ -277,13 +243,5 @@
          vs_atl, vs_pac, vs_ind,           &
          zv_eiv
-      CHARACTER (len=32) ::   &
-         clnam = 'subbasins.nc'                
-      INTEGER ::  itime,inum,ipi,ipj,ipk       ! temporary integer
-      INTEGER, DIMENSION (1) ::   istep
-      REAL(wp) ::    zdate0,zsecond,zdt        ! temporary scalars
-      REAL(wp), DIMENSION(jpidta,jpjdta) ::   &
-         zlamt, zphit, zdta             ! temporary workspace (NetCDF read)
-      REAL(wp), DIMENSION(jpk) ::   &
-         zdept                          ! temporary workspace (NetCDF read)
+      INTEGER ::  inum       ! temporary logical unit
       !!----------------------------------------------------------------------
 
@@ -293,10 +251,4 @@
          zpwatt    = 1.e-15
          zggram    = 1.e-6
-         ipi       = jpidta
-         ipj       = jpjdta
-         ipk       = 1
-         itime     = 1
-         zsecond   = 0.e0
-         zdate0    = 0.e0
    
 # if defined key_diaeiv
@@ -315,50 +267,10 @@
          IF( ln_subbas ) THEN              ! Basins computation
 
-            IF( kt == nit000 ) THEN                ! load basin mask
-               itime = 1
-               ipi   = jpidta
-               ipj   = jpjdta
-               ipk   = 1
-               zdt   = 0.e0
-               istep = 0
-               clnam = 'subbasins.nc'
-
-               CALL flinopen(clnam,1,jpidta,1,jpjdta,.FALSE.,ipi,ipj, &
-                  &          ipk,zlamt,zphit,zdept,itime,istep,zdate0,zdt,inum)
-
-               ! get basins:
-               abasin (:,:) = 0.e0
-               pbasin (:,:) = 0.e0
-               ibasin (:,:) = 0.e0
-
-               ! Atlantic basin
-               CALL flinget(inum,'atlmsk',jpidta,jpjdta,1,itime,1,   &
-                  &         0,1,jpidta,1,jpjdta,zdta(:,:))
-               DO jj = 1, nlcj                                 ! interior values
-                  DO ji = 1, nlci
-                     abasin (ji,jj) = zdta( mig(ji), mjg(jj) )
-                  END DO
-               END DO
-
-               ! Pacific basin
-               CALL flinget(inum,'pacmsk',jpidta,jpjdta,1,itime,1,   &
-                  &         0,1,jpidta,1,jpjdta,zdta(:,:))
-               DO jj = 1, nlcj                                 ! interior values
-                  DO ji = 1, nlci
-                     pbasin (ji,jj) = zdta( mig(ji), mjg(jj) )
-                  END DO
-               END DO
-
-               ! Indian basin
-               CALL flinget(inum,'indmsk',jpidta,jpjdta,1,itime,1,   &
-                  &         0,1,jpidta,1,jpjdta,zdta(:,:))
-               DO jj = 1, nlcj                                 ! interior values
-                  DO ji = 1, nlci
-                     ibasin (ji,jj) = zdta( mig(ji), mjg(jj) )
-                  END DO
-               END DO
-
-               CALL flinclo(inum)
-
+            IF( kt == nit000 ) THEN                ! load sub-basin mask
+               CALL iom_open( 'subbasins', inum )
+               CALL iom_get( inum, jpdom_data, 'atlmsk', abasin )      ! Atlantic basin
+               CALL iom_get( inum, jpdom_data, 'pacmsk', pbasin )      ! Pacific basin
+               CALL iom_get( inum, jpdom_data, 'indmsk', ibasin )      ! Indian basin
+               CALL iom_close( inum )
             ENDIF
 
@@ -396,12 +308,12 @@
 #endif
          IF( ln_subbas ) THEN
-            v_msf_atl(:,:) = ptr_vjk( v_atl(:,:,:) ) 
-            v_msf_ipc(:,:) = ptr_vjk( v_ipc(:,:,:) ) 
-            ht_atl(:) = SUM(ptr_vjk( vt_atl(:,:,:)),2 )
-            ht_pac(:) = SUM(ptr_vjk( vt_pac(:,:,:)),2 )
-            ht_ind(:) = SUM(ptr_vjk( vt_ind(:,:,:)),2 )
-            st_atl(:) = SUM(ptr_vjk( vs_atl(:,:,:)),2 )
-            st_pac(:) = SUM(ptr_vjk( vs_pac(:,:,:)),2 )
-            st_ind(:) = SUM(ptr_vjk( vs_ind(:,:,:)),2 )
+            v_msf_atl(:,:) = ptr_vjk( v_atl (:,:,:) ) 
+            v_msf_ipc(:,:) = ptr_vjk( v_ipc (:,:,:) ) 
+            ht_atl(:) = SUM( ptr_vjk( vt_atl(:,:,:)), 2 )
+            ht_pac(:) = SUM( ptr_vjk( vt_pac(:,:,:)), 2 )
+            ht_ind(:) = SUM( ptr_vjk( vt_ind(:,:,:)), 2 )
+            st_atl(:) = SUM( ptr_vjk( vs_atl(:,:,:)), 2 )
+            st_pac(:) = SUM( ptr_vjk( vs_pac(:,:,:)), 2 )
+            st_ind(:) = SUM( ptr_vjk( vs_ind(:,:,:)), 2 )
          ENDIF
 
@@ -466,5 +378,5 @@
       ! Close the file
       IF( kt == nitend ) CALL histclo( numptr )
-
+      !
    END SUBROUTINE dia_ptr
 
@@ -475,5 +387,4 @@
       !!                   
       !! ** Purpose :   Initialization, namelist read
-      !!
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   z_1         ! temporary workspace
@@ -485,5 +396,4 @@
       REWIND ( numnam )
       READ   ( numnam, namptr )
-
 
       ! Control print
@@ -513,19 +423,12 @@
       !!
       !! ** Method  :   NetCDF file
-      !!
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
-
-      !! * Save variables   
+      !!
       INTEGER, SAVE ::   nhoridz, ndepidzt, ndepidzw, ndex(1)
 
-      !! * Local variables
-      CHARACTER (len=40) ::   &
-         clhstnam, clop             ! temporary names
-      INTEGER ::   iline, it, ji    !
-      REAL(wp) ::   &
-         zsto, zout, zdt, zmax, &   ! temporary scalars
-         zjulian
+      CHARACTER (len=40)       ::   clhstnam, clop                   ! temporary names
+      INTEGER                  ::   iline, it, ji                    !
+      REAL(wp)                 ::   zsto, zout, zdt, zmax, zjulian   ! temporary scalars
       REAL(wp), DIMENSION(jpj) ::   zphi, zfoo
       !!----------------------------------------------------------------------
@@ -720,5 +623,5 @@
  
       ENDIF
-
+      !
    END SUBROUTINE dia_ptr_wri
 
Index: trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 508)
@@ -4,14 +4,23 @@
    !! Ocean dynamics:  surface pressure gradient trend
    !!======================================================================
-#if ( defined key_dynspg_flt && ! defined key_mpp_omp )   ||   defined key_esopa
+   !! History    8.0  !  98-05  (G. Roullet)  free surface
+   !!                 !  98-10  (G. Madec, M. Imbard)  release 8.2
+   !!            8.5  !  02-08  (G. Madec)  F90: Free form and module
+   !!            " "  !  02-11  (C. Talandier, A-M Treguier) Open boundaries
+   !!            9.0  !  04-08  (C. Talandier) New trends organization
+   !!            " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!            " "  !  06-07  (S. Masson)  distributed restart using iom
+   !!----------------------------------------------------------------------
+#if ( defined key_dynspg_flt  && ! defined key_mpp_omp )  ||   defined key_esopa  
    !!----------------------------------------------------------------------
    !!   'key_dynspg_flt'                              filtered free surface
    !!   NOT 'key_mpp_omp'                          k-j-i loop (vector opt.)
+   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   dyn_spg_flt  : update the momentum trend with the surface pressure
    !!                  gradient in the filtered free surface case with
    !!                  vector optimization
-   !!----------------------------------------------------------------------
-   !! * Modules used
+   !!   flt_rst      : read/write the time-splitting restart fields in the ocean restart file
+   !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers 
    USE dom_oce         ! ocean space and time domain 
@@ -21,4 +30,5 @@
    USE flxrnf          ! ocean runoffs
    USE sol_oce         ! ocean elliptic solver
+   USE solver          ! solver initialization
    USE solpcg          ! preconditionned conjugate gradient solver
    USE solsor          ! Successive Over-relaxation solver
@@ -32,12 +42,13 @@
    USE cla_dynspg      ! cross land advection
    USE prtctl          ! Print control
-   USE in_out_manager  ! I/O manager
    USE solmat          ! matrix construction for elliptic solvers
    USE agrif_opa_interp
+   USE in_out_manager  ! I/O manager
+   USE iom
+   USE restart         ! only for lrst_oce
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
    PUBLIC dyn_spg_flt  ! routine called by step.F90
 
@@ -48,5 +59,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
@@ -96,28 +107,15 @@
       !! ** Action : - Update (ua,va) with the surf. pressure gradient trend
       !!
-      !! References :
-      !!      Roullet and Madec 1999, JGR.
-      !!
-      !! History :
-      !!        !  98-05 (G. Roullet)  Original code
-      !!        !  98-10 (G. Madec, M. Imbard)  release 8.2
-      !!   8.5  !  02-08 (G. Madec)  F90: Free form and module
-      !!        !  02-11 (C. Talandier, A-M Treguier) Open boundaries
-      !!   9.0  !  04-08 (C. Talandier) New trends organization
-      !!    "   !  05-11  (V. Garnier) Surface pressure gradient organization
+      !! References : Roullet and Madec 1999, JGR.
       !!---------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT( in )  ::   kt         ! ocean time-step index
-      INTEGER, INTENT( out ) ::   kindic     ! solver convergence flag
-                                             ! if the solver doesn t converge
-                                             ! the flag is < 0
-      !! * Local declarations
-      INTEGER  ::   ji, jj, jk               ! dummy loop indices
-      REAL(wp) ::                         & 
-         z2dt, z2dtg, zraur, znugdt,      &  ! temporary scalars
-         znurau, zssha, zgcb, zbtd,       &  !   "          "
-         ztdgu, ztdgv                        !   "          "
+      INTEGER, INTENT( out ) ::   kindic     ! solver convergence flag (<0 if not converge)
+      !!                                   
+      INTEGER  ::   ji, jj, jk                          ! dummy loop indices
+      REAL(wp) ::   z2dt, z2dtg, zraur, znugdt,      &  ! temporary scalars
+         &          znurau, zssha, zgcb, zbtd,       &  !   "          "
+         &          ztdgu, ztdgv                        !   "          "
       !!----------------------------------------------------------------------
-
+      !
       IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
@@ -128,4 +126,9 @@
          spgu(:,:) = 0.e0                     ! surface pressure gradient (i-direction)
          spgv(:,:) = 0.e0                     ! surface pressure gradient (j-direction)
+         CALL solver_init( nit000 )           ! Elliptic solver initialisation
+
+         ! read filtered free surface arrays in restart file
+         CALL flt_rst( nit000, 'READ' )       ! read or initialize the following fields:
+         !                                    ! gcx, gcxb, sshb, sshn
       ENDIF
 
@@ -168,13 +171,9 @@
 
 #if defined key_obc
-      ! Update velocities on each open boundary with the radiation algorithm
-      CALL obc_dyn( kt )
-      ! Correction of the barotropic componant velocity to control the volume of the system
-      CALL obc_vol( kt )
+      CALL obc_dyn( kt )      ! Update velocities on each open boundary with the radiation algorithm
+      CALL obc_vol( kt )      ! Correction of the barotropic componant velocity to control the volume of the system
 #endif
 #if defined key_agrif
-      ! Update velocities on each coarse/fine interfaces
-
-      CALL Agrif_dyn( kt )
+      CALL Agrif_dyn( kt )    ! Update velocities on each coarse/fine interfaces 
 #endif
 #if defined key_orca_r2
@@ -243,12 +242,12 @@
       IF( .NOT. AGRIF_ROOT() ) THEN
          ! add contribution of gradient of after barotropic transport divergence 
-         IF( (nbondi == -1) .OR. (nbondi == 2) ) gcb(3,:) = gcb(3,:) &
-            &            -znugdt * z2dt*laplacu(2,:)*gcdprc(3,:)*hu(2,:)*e2u(2,:)
-         IF( (nbondi ==  1) .OR. (nbondi == 2) )  gcb(nlci-2,:) = gcb(nlci-2,:) &
-            &           +znugdt * z2dt*laplacu(nlci-2,:)*gcdprc(nlci-2,:)*hu(nlci-2,:)*e2u(nlci-2,:)
-         IF( (nbondj == -1) .OR. (nbondj == 2) ) gcb(:,3) = gcb(:,3) &
-            &           -znugdt * z2dt*laplacv(:,2)*gcdprc(:,3)*hv(:,2)*e1v(:,2)
-         IF( (nbondj ==  1) .OR. (nbondj == 2) )  gcb(:,nlcj-2) = gcb(:,nlcj-2) &
-            &           +znugdt * z2dt*laplacv(:,nlcj-2)*gcdprc(:,nlcj-2)*hv(:,nlcj-2)*e1v(:,nlcj-2)
+         IF( nbondi == -1 .OR. nbondi == 2 )   gcb(3     ,:) =   &
+            &    gcb(3     ,:) - znugdt * z2dt * laplacu(2     ,:) * gcdprc(3     ,:) * hu(2     ,:) * e2u(2     ,:)
+         IF( nbondi ==  1 .OR. nbondi == 2 )   gcb(nlci-2,:) =   &
+            &    gcb(nlci-2,:) + znugdt * z2dt * laplacu(nlci-2,:) * gcdprc(nlci-2,:) * hu(nlci-2,:) * e2u(nlci-2,:)
+         IF( nbondj == -1 .OR. nbondj == 2 )   gcb(:     ,3) =   &
+            &    gcb(:,3     ) - znugdt * z2dt * laplacv(:,2     ) * gcdprc(:,3     ) * hv(:,2     ) * e1v(:,2     )
+         IF( nbondj ==  1 .OR. nbondj == 2 )   gcb(:,nlcj-2) =   &
+            &    gcb(:,nlcj-2) + znugdt * z2dt * laplacv(:,nlcj-2) * gcdprc(:,nlcj-2) * hv(:,nlcj-2) * e1v(:,nlcj-2)
       ENDIF
 #endif
@@ -263,5 +262,5 @@
       epsr = eps * eps * rnorme
       ncut = 0
-      ! if rnorme is 0, the solution is 0, the solver isn't called
+      ! if rnorme is 0, the solution is 0, the solver is not called
       IF( rnorme == 0.e0 ) THEN
          gcx(:,:) = 0.e0
@@ -313,8 +312,8 @@
       IF( .NOT. Agrif_Root() ) THEN
          ! caution : grad D (fine) = grad D (coarse) at coarse/fine interface
-         IF( (nbondi == -1) .OR. (nbondi == 2) ) spgu(2,:) = znugdt * z2dt * laplacu(2,:) * umask(2,:,1)
-         IF( (nbondi ==  1) .OR. (nbondi == 2) ) spgu(nlci-2,:) = znugdt * z2dt * laplacu(nlci-2,:) * umask(nlci-2,:,1)
-         IF( (nbondj == -1) .OR. (nbondj == 2) ) spgv(:,2) = znugdt * z2dt * laplacv(:,2) * vmask(:,2,1)
-         IF( (nbondj ==  1) .OR. (nbondj == 2) ) spgv(:,nlcj-2) = znugdt * z2dt * laplacv(:,nlcj-2) * vmask(:,nlcj-2,1)
+         IF( nbondi == -1 .OR. nbondi == 2 ) spgu(2     ,:) = znugdt * z2dt * laplacu(2     ,:) * umask(2     ,:,1)
+         IF( nbondi ==  1 .OR. nbondi == 2 ) spgu(nlci-2,:) = znugdt * z2dt * laplacu(nlci-2,:) * umask(nlci-2,:,1)
+         IF( nbondj == -1 .OR. nbondj == 2 ) spgv(:,2     ) = znugdt * z2dt * laplacv(:,2     ) * vmask(:     ,2,1)
+         IF( nbondj ==  1 .OR. nbondj == 2 ) spgv(:,nlcj-2) = znugdt * z2dt * laplacv(:,nlcj-2) * vmask(:,nlcj-2,1)
       ENDIF
 #endif      
@@ -323,5 +322,5 @@
       !     ( c a u t i o n : (ua,va) here are the after velocity not the
       !                       trend, the leap-frog time stepping will not
-      !                       be done in dynnxt.F routine)
+      !                       be done in dynnxt.F90 routine)
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
@@ -332,5 +331,4 @@
          END DO
       END DO
-
 
       ! Sea surface elevation time stepping
@@ -358,8 +356,52 @@
       ENDIF
 
-      !                       ! print sum trends (used for debugging)
-      IF(ln_ctl)   CALL prt_ctl( tab2d_1=sshn, clinfo1=' spg  - ssh: ', mask1=tmask )
-
+      ! write filtered free surface arrays in restart file
+      ! --------------------------------------------------
+      IF( lrst_oce ) CALL flt_rst( kt, 'WRITE' )
+
+      ! print sum trends (used for debugging)
+      IF(ln_ctl)     CALL prt_ctl( tab2d_1=sshn, clinfo1=' spg  - ssh: ', mask1=tmask )
+      !
    END SUBROUTINE dyn_spg_flt
+
+
+   SUBROUTINE flt_rst( kt, cdrw )
+     !!---------------------------------------------------------------------
+     !!                   ***  ROUTINE ts_rst  ***
+     !!
+     !! ** Purpose : Read or write filtered free surface arrays in restart file
+     !!----------------------------------------------------------------------
+     INTEGER         , INTENT(in) ::   kt         ! ocean time-step
+     CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
+     !!----------------------------------------------------------------------
+
+     IF( TRIM(cdrw) == 'READ' ) THEN
+        IF( iom_varid( numror, 'gcx' ) > 0 ) THEN
+! Caution : extra-hallow
+! gcx and gcxb are defined as: DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj)
+           CALL iom_get( numror, jpdom_local, 'gcx' , gcx (1:jpi,1:jpj) )
+           CALL iom_get( numror, jpdom_local, 'gcxb', gcxb(1:jpi,1:jpj) )
+           CALL iom_get( numror, jpdom_local, 'sshb', sshb(:,:)         )
+           CALL iom_get( numror, jpdom_local, 'sshn', sshn(:,:)         )
+           IF( neuler == 0 ) THEN
+              sshb(:,:) = sshn(:,:)
+              gcxb(:,:) = gcx (:,:)
+           ENDIF
+        ELSE
+           gcx (:,:) = 0.e0
+           gcxb(:,:) = 0.e0
+           sshb(:,:) = 0.e0
+           sshn(:,:) = 0.e0
+        ENDIF
+     ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
+! Caution : extra-hallow
+! gcx and gcxb are defined as: DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj)
+        CALL iom_rstput( kt, nitrst, numrow, 'gcx' , gcx( 1:jpi,1:jpj) )
+        CALL iom_rstput( kt, nitrst, numrow, 'gcxb', gcxb(1:jpi,1:jpj) )
+        CALL iom_rstput( kt, nitrst, numrow, 'sshb', sshb(:,:)         )
+        CALL iom_rstput( kt, nitrst, numrow, 'sshn', sshn(:,:)         )
+     ENDIF
+     !
+   END SUBROUTINE flt_rst
 
 #else
